{{
  Written by Duane Degn
}}      
CON
  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000

 
  MAX_SPEED = 200             
  MIN_SPEED = 1
  
  ACCELERATION = 2 
  
  DISTANCE_TO_MOVE = 40_000

  MAX_DISPLAY_Y = 220
  DISPLAY_SCALE = DISTANCE_TO_MOVE / MAX_DISPLAY_Y
  
  ' driverState enumeration
  #0, RAMP_UP, FULL_SPEED, RAMP_DOWN, STOP

VAR

  long speed, time, distance, activeAcceleration
  long rampDownTarget
  
  byte driverState
  
OBJ

  Pst : "Parallax Serial Terminal" 
      
PUB Main

  Pst.Start(115_200)
  driverState := RAMP_UP
  speed := 0
  activeAcceleration := ACCELERATION
  repeat
    Pst.str(string(13, "Press any key to start."))
    result := Pst.RxCount
  while result == 0
  Pst.Clear  
  repeat 
    Move
    Pst.Str(string(13, "t = "))
    Pst.Dec(time++)
    Pst.PositionX(9)
    Pst.Str(string(", a = "))
    Pst.Dec(activeAcceleration)
    Pst.PositionX(17)
    Pst.Str(string(", s = "))
    Pst.Dec(speed)
    Pst.PositionX(26)
    Pst.Str(string(", d = "))
    Pst.Dec(distance)
    'term.plot(time++, MAX_DISPLAY_Y - (distance / DISPLAY_SCALE))
  while driverState <> STOP
  repeat

PUB Move

  speed += activeAcceleration
  distance += speed

  case driverState
    RAMP_UP:
      RampUp 
    FULL_SPEED:
      FullSpeed
    RAMP_DOWN:
      RampDown
        
PUB RampUp

  result := speed + activeAcceleration
  if result => MAX_SPEED
    speed := MAX_SPEED      
    rampDownTarget := (DISTANCE_TO_MOVE - distance) + 1
    if rampDownTarget =< 0
      driverState := RAMP_DOWN
      activeAcceleration := -ACCELERATION
    else
      driverState := FULL_SPEED
      Pst.Str(string(13, "FULL_SPEED"))
      activeAcceleration := 0
  'else
    'speed := result
          
PUB FullSpeed

  if distance + speed => rampDownTarget
    driverState := RAMP_DOWN
    activeAcceleration := -ACCELERATION
    Pst.Str(string(13, "RAMP_DOWN"))
    
PUB RampDown

  result := speed + activeAcceleration
  if result < MIN_SPEED
    activeAcceleration := MIN_SPEED - speed ' still want accleration to be negative or zero.
    Pst.Str(string(13, "activeAcceleration = "))
    Pst.Dec(activeAcceleration)
  if distance + result => DISTANCE_TO_MOVE
    speed := DISTANCE_TO_MOVE - distance ' set speed to just reach the end of travel
    activeAcceleration := 0 ' don't change speed any more
    driverState := STOP
    Pst.Str(string(13, "STOP"))
  'else
    'speed := result
    